# react-redux-datatable

[![Build Status](https://travis-ci.org/sean-ww/react-redux-datatable.svg?branch=master)](https://travis-ci.org/sean-ww/react-redux-datatable)
[![Coverage Status](https://coveralls.io/repos/github/sean-ww/react-redux-datatable/badge.svg?branch=master)](https://coveralls.io/github/sean-ww/react-redux-datatable?branch=master)
[![Version](https://img.shields.io/npm/v/react-redux-datatable.svg)](https://www.npmjs.org/package/react-redux-datatable)
[![GitHub license](https://img.shields.io/badge/license-MIT-blue.svg)](https://raw.githubusercontent.com/sean-ww/react-redux-datatable/master/LICENSE)

Dynamic data table using React and Redux that fetches JSON from a predefined API. Designed to build asynchronous React-Redux tables quickly and consistently.

![Example](https://github.com/sean-ww/react-redux-datatable/raw/master/react-redux-datatable.png)

* Filter column values by date ranges, number, text and select lists
* Paginate and Sort data
* Configurable table and column widths
* Ability to add custom filters and column formatters
* Optional local storage of filter data
* Uses React and Redux with a predefined API
* Add table headers
* Toggle full screen view
* Export to csv

### Demo

[View the Demo](https://sean-ww.github.io/react-redux-datatable/demo/?selectedKind=General%20Demo&selectedStory=Advanced%20Features&full=0&addons=0&stories=1&panelRight=0)

### Documentation

[You will find full documentation here](https://sean-ww.github.io/react-redux-datatable)

### Contributing

See the [Contributors Guide](https://github.com/sean-ww/react-redux-datatable/blob/master/CONTRIBUTING.md)

### License

The MIT License (MIT). Please view the [License File](https://github.com/sean-ww/react-redux-datatable/blob/master/LICENSE) for more information.
