'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _enzyme = require('enzyme');

var _PageButton = require('./PageButton/PageButton');

var _PageButton2 = _interopRequireDefault(_PageButton);

var _PaginationList = require('./PaginationList');

var _PaginationList2 = _interopRequireDefault(_PaginationList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<PaginationList>', function () {
  var wrapper = void 0;
  var onPageChange = _sinon2.default.stub();
  var pages = [{
    page: 1,
    active: false,
    title: '1'
  }, {
    page: 2,
    active: true,
    title: '2'
  }, {
    page: 3,
    active: false,
    title: '3'
  }];

  beforeEach(function () {
    wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_PaginationList2.default, { pages: pages, onPageChange: onPageChange }));
  });

  it('should render PaginatonList correctly', function () {
    (0, _chai.expect)(wrapper.length).to.equal(1);
    (0, _chai.expect)(wrapper.find('ul.react-bootstrap-table-page-btns-ul').length).to.equal(1);
    (0, _chai.expect)(wrapper.find(_PageButton2.default).length).to.equal(3);
  });
});