'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _chai = require('chai');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _DateRangeInputField = require('./DateRangeInputField');

var _DateRangeInputField2 = _interopRequireDefault(_DateRangeInputField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('<DateRangeInputField>', function () {
  var Component = void 0;
  beforeEach(function () {
    Component = (0, _enzyme.shallow)(_react2.default.createElement(_DateRangeInputField2.default, { handleDayClick: function handleDayClick() {}, from: null, to: null }));
  });

  it('should display Please select the first day', function () {
    (0, _chai.expect)(Component.find('.dateRangeText').first().text()).to.equal('Please select the first day.');
  });

  describe('Select the first day', function () {
    beforeEach(function () {
      var from = (0, _moment2.default)('20111031').toDate();
      Component.setProps({ from: from });
    });

    it('should display Please select the last day', function () {
      (0, _chai.expect)(Component.find('.dateRangeText').first().text()).to.equal('Please select the last day.');
    });

    describe('Select the last day after the first', function () {
      beforeEach(function () {
        var to = (0, _moment2.default)('20120620').toDate();
        Component.setProps({ to: to });
      });

      it('should display the date range selected', function () {
        (0, _chai.expect)(Component.find('.dateRangeText').first().text()).to.equal('You chose from 31/10/2011 to 20/06/2012.');
      });
    });

    describe('Select the last day before the first', function () {
      beforeEach(function () {
        var to = (0, _moment2.default)('20100620').toDate();
        Component.setProps({ to: to });
      });

      it('should display the date range selected', function () {
        (0, _chai.expect)(Component.find('.dateRangeText').first().text()).to.equal('You chose from 20/06/2010 to 31/10/2011.');
      });
    });

    describe('Select the last day equal to the first', function () {
      beforeEach(function () {
        var to = (0, _moment2.default)('20111031').toDate();
        Component.setProps({ to: to });
      });

      it('should display the date range selected', function () {
        (0, _chai.expect)(Component.find('.dateRangeText').first().text()).to.equal('You chose from 31/10/2011 to 31/10/2011.');
      });
    });
  });
});