'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var endIndex = function endIndex(page, sizePerPage) {
  return page * sizePerPage - 1;
};

var startIndex = function startIndex(end, sizePerPage) {
  return end - (sizePerPage - 1);
};

var alignPage = exports.alignPage = function alignPage(data, page, sizePerPage) {
  var dataSize = data.length;

  if (page < 1 || page > Math.floor(dataSize / sizePerPage) + 1) {
    return 1;
  }
  return page;
};

var getByCurrPage = exports.getByCurrPage = function getByCurrPage(data, page, sizePerPage) {
  console.log('getByCurrPage', data, page, sizePerPage);
  var dataSize = data.length;
  if (!dataSize) return [];

  var end = endIndex(page, sizePerPage);
  var start = startIndex(end, sizePerPage);

  var result = [];
  for (var i = start; i <= end; i += 1) {
    result.push(data[i]);
    if (i + 1 === dataSize) break;
  }
  return result;
};