'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _page = require('../src/page');

describe('Page Functions', function () {
  var data = void 0;
  var params = [
  // [page, sizePerPage, pageStartIndex]
  [1, 10, 1], [1, 25, 1], [1, 30, 1], [3, 30, 1], [4, 30, 1], [10, 10, 1], [0, 10, 0], [1, 10, 0], [9, 10, 0]];

  describe('getByCurrPage', function () {
    beforeEach(function () {
      data = [];
      for (var i = 0; i < 100; i += 1) {
        data.push({ id: i, name: 'test_name' + i });
      }
    });

    it('should always return correct data', function () {
      params.forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 3),
            page = _ref2[0],
            sizePerPage = _ref2[1],
            pageStartIndex = _ref2[2];

        var rows = (0, _page.getByCurrPage)(data, page, sizePerPage, pageStartIndex);
        expect(rows).toBeDefined();
        expect(Array.isArray(rows)).toBeTruthy();
        expect(rows.every(function (row) {
          return !!row;
        })).toBeTruthy();
      });
    });

    it('should return empty array when data is empty', function () {
      data = [];
      params.forEach(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 3),
            page = _ref4[0],
            sizePerPage = _ref4[1],
            pageStartIndex = _ref4[2];

        var rows = (0, _page.getByCurrPage)(data, page, sizePerPage, pageStartIndex);
        expect(rows).toHaveLength(0);
      });
    });
  });

  describe('alignPage', function () {
    var pageStartIndex = 1;
    var sizePerPage = 10;
    var page = 3;
    describe('if the page does not fit the pages interval calculated from the length of store.data', function () {
      beforeEach(function () {
        data = [];
        for (var i = 0; i < 15; i += 1) {
          data.push({ id: i, name: 'test_name' + i });
        }
      });

      it('should return pageStartIndex argument', function () {
        expect((0, _page.alignPage)(data, page, sizePerPage, pageStartIndex)).toEqual(pageStartIndex);
      });
    });

    describe('if the length of store.data is large than the end page index', function () {
      beforeEach(function () {
        data = [];
        for (var i = 0; i < 30; i += 1) {
          data.push({ id: i, name: 'test_name' + i });
        }
      });

      it('should return current page', function () {
        expect((0, _page.alignPage)(data, page, sizePerPage, pageStartIndex)).toEqual(page);
      });
    });
  });
});